declare("ledger", {})
ledger.version = '0.4.5 (20110609-0911)'
--[url=http://bespin.org/~draugath/vo/ledger/ledger_0.4.5a1.zip]ledger_0.4.5a1.zip[/url]

-- TODO
-- rework categories and filters
-- 


-- Functions
ledger.init = {}
ledger.log = {}
ledger.record = {}

local timer1 = Timer() -- used to wait for CHAT_MSG_CONFIRMATION after CHAT_MSG_SECTORD_MISSION before comitting
local commit_func
local kill = false

local buyback = false
local last_purchase
local stored_purchases = {}

dofile('vars.lua')
dofile('ui.lua')
dofile('fuzzytime.lua')

function ledger.save(tbl)
	if (type(tbl) ~= 'table') then return nil, 'Table expected, got '..type(tbl)..'.' end
	return pcall(SaveSystemNotes, spickle(tbl), ledger.notesid)
end

local function check_purchase(event, data)
--	test.print('event='..tostring(event)..' / data='..tostring(data)..' / buyback='..tostring(buyback))
	if (event == 'INVENTORY_ADD') then
		if (not buyback) then
			buyback = (GetInventoryItemName(data):match('%s[Ee]ngine$') or false) and data
--			test.print('buyback='..tostring(buyback))
		else
--			test.print('type(buyback)='..type(buyback))
			if (type(buyback) == 'number') then
				if (buyback == data + 1) then buyback = true end
--				test.print('buyback='..tostring(buyback))
			end
			last_purchase = GetInventoryItemName(data)
			if (last_purchase == 'EC-88' or last_purchase == 'EC-89') then
				store_purchase(0)
			end
		end
	end
end

local function store_purchase(credits)
	local name = last_purchase
	if (stored_purchases[name]) then
		stored_purchases[name].qty = stored_purchases[name].qty + 1
	else
		stored_purchases[name] = {}
		stored_purchases[name].qty = 1
		stored_purchases[name].cost = credits
	end
end

function ledger.log(event, data)
	local credits, notes, target, category, typeof = 0, ''
	local rfilter = ledger.filter.record

--test.print('start of log()\nevent='..tostring(event)..' / kill='..tostring(kill)..' / timerActive='..tostring(timer1:IsActive()))


	if (event == "CHAT_MSG_CONFIRMATION") then
--		test.print('start of CHAT_MSG_CONFIRMATION')
		-- Event: Purchase failed.
		if     (data.msg:match('Items purchase failed%.')) then
			ledger.vars.purchase_failed = true

		-- Event: Preset purchase cancelled
		elseif (data.msg:match('Preset purchase cancelled')) then
		--Event: CHAT_MSG_CONFIRMATION - Data:msg="Preset purchase cancelled but some items may have been purchased."
			target = "Preset or last ship purchase"
			category, typeof = 'station.buy', 'Debit'
			for k, v in pairs(stored_purchases) do 
				credits = credits + v.cost
				notes = notes..v.qty..'x '..k..', ' 
			end
			buyback = false
			stored_purchases = {}
			notes = notes:gsub(', $', '')
			notes = 'Preset purchase cancelled. ('..notes..' purchased)'

		-- Event: /givemoney - Send
		elseif (rfilter.player.send and data.msg:match("Initiating transfer")) then 
			-- Event:CHAT_MSG_CONFIRMATION - Data:msg="Initiating transfer of 1 credits to Conflict Diamond..."
			credits, target = data.msg:match("([%d,]+) credits to (.*)%.%.%.")
			category, typeof = 'player.send', 'Debit'

		-- Event: Reload ship
		elseif (rfilter.ship.reload and data.msg:match("^All ammo") and not data.msg:match("^Items purchased%.$")) then
			-- Event:CHAT_MSG_CONFIRMATION - Data:msg="1x of Purified Water purchased for a total price of 8c."
			target, credits = data.msg:match("^(.*) purchased.-([%d,]+)c%.$")
			category, typeof = 'ship.reload', 'Debit'

		-- Event: Purchase ship
		elseif (rfilter.ship.buy and ledger.vars.shiplist[data.msg:match("of (.*) purchased")] and not data.msg:match("^Items purchased%.$")) then
			-- Event:CHAT_MSG_CONFIRMATION - Data:msg="1x of EC-89 purchased for a total price of 8c."
			target, credits = data.msg:match("^(.*) purchased.-([%d,]+)c%.$")
			category, typeof = 'ship.buy', 'Debit'
			if (buyback) then 
				buyback = false 
				stored_purchases = {}
			end

		-- Event: Purchase item
		elseif (rfilter.station.buy and data.msg:match("purchased") and not data.msg:match("^Items purchased%.$")) then
			-- Event:CHAT_MSG_CONFIRMATION - Data:msg="1x of Purified Water purchased for a total price of 8c."
			target, credits = data.msg:match("^(.*) purchased.-([%d,]+)c%.$")
			category, typeof = 'station.buy', 'Debit'

		-- Event: Sell ship
		elseif (rfilter.ship.sell and ledger.vars.shiplist[data.msg:match("of (.*) sold")]) then
			-- Event:CHAT_MSG_CONFIRMATION - Data:msg="1x of EC-89 sold for a total amount of 0c (loss of 0c)"
			target, credits, notes = data.msg:match("^(.*) sold.-([%d,]+)c (%(.*%))$")
			category, typeof = 'ship.sell', 'Credit'

		-- Event: Sell item
		elseif (rfilter.station.sell and data.msg:match("sold")) then
			-- Event:CHAT_MSG_CONFIRMATION - Data:msg="1x of Purified Water sold for a total amount of 7c (loss of 1c)"
			target, credits, notes = data.msg:match("^(.*) sold.-([%d,]+)c (%(.*%))$")
			category, typeof = 'station.sell', 'Credit'

		-- Event: Repair ship
		elseif (rfilter.ship.repair and data.msg:match("^Ship repaired")) then
			-- Event:CHAT_MSG_CONFIRMATION - Data:msg="Ship repaired for a total price of 59c."
			target, credits = data.msg:match("^(Ship repair).-([%d,]+)c%.")
			category, typeof = 'ship.repair', 'Debit'

		-- Event: Rebuy last ship
		elseif (rfilter.station.buy and data.msg:match("^Total cost of purchase")) then
			-- Event:CHAT_MSG_CONFIRMATION - Data:msg="Total cost of purchase is 577 credits"
			target, credits = "Preset or last ship purchase", data.msg:match("([%d,]+) credits")
			category, typeof = 'station.buy', 'Debit'

			for k, v in pairs(stored_purchases) do notes = notes..v.qty..'x '..k..', ' end
			buyback = false
			stored_purchases = {}
			notes = notes:gsub(', $', '')
		end

--		test.print('end of CHAT_MSG_CONFIRMATION')

	elseif (event == "CHAT_MSG_SECTORD") then
		-- Event: /givemoney - Receive
		if (rfilter.player.receive and data.msg:match("sent you %d+ credits%.")) then
			-- Event:CHAT_MSG_SECTORD - Data:msg="Conflict Diamond sent you 1 credits."
			target, credits = data.msg:match("^(.*) sent you ([%d,]+) credits%.$")
			category, typeof = 'player.receive', 'Credit'
		end


	elseif (event == "CHAT_MSG_SECTORD_MISSION") then
--		test.print('start of CHAT_MSG_SECTORD_MISSION')
		--Event: CHAT_MSG_SECTORD_MISSION - Data:missionid=0,msg="Nice shot!" or msg="Clean kill!"
		if (rfilter.mission.kill and (data.msg == 'Nice shot!' or data.msg == 'Clean kill!')) then
			kill = true --test.print('kill=true')
			return
		end

		--Event: CHAT_MSG_SECTORD_MISSION - Data:msg="50000 credits [added|deducted] [to|from] your account."
		--Will be followed by a CHAT_MSG_CONFIRMATION if it was a sale, unless it was a buyback/preset

		credits, typeof = data.msg:match("^(%d+) credits (%w+)")
		if (credits) then
			if (buyback) then
				store_purchase(credits)
			elseif (rfilter.mission.trans or rfilter.mission.kill) then
				target, notes = 'Mission Transaction', GetActiveMissionInfo(1)
				credits, typeof = data.msg:match("^(%d+) credits (%w+)")
				category, typeof = 'mission.trans', (typeof == 'added' and 'Credit' or 'Debit')

				--commit any pending mission rewards
				if (timer1:IsActive() and target and credits) then 
	--				test.print('Timer Killed') 
					timer1:Kill() 
					commit_func()
				end

				-- if not a kill reward, start timer to delay commit of mission reward in case part of a sale
				if (not kill) then
	--				test.print('writing function')
					commit_func = function() if (target and credits) then ledger.record(category, target, typeof, credits, notes) end end
	--				test.print('setting timer')
					timer1:SetTimeout(ledger.vars.timerdelay, commit_func)
					ledger.starttime = gkmisc.GetGameTime()
	--				test.print('timerdelay='..tostring(ledger.vars.timerdelay)..'\nstarttime='..tostring(ledger.starttime))
					return
				else
	--				test.print('event='..tostring(event)..' / msg='..tostring(data.msg))
	--				test.print('category='..tostring(category)..' / target='..tostring(target)..' / typeof='..tostring(typeof)..' / credits='..tostring(credits)..' / notes='..tostring(notes))
					notes = (notes or '')..' - Kill Reward'
					kill = false --test.print('kill=false')
				end
			end
		end
--		test.print('end of CHAT_MSG_SECTORD_MISSION')

	elseif (event == 'CHAT_MSG_SERVER') then
		-- Event: Deposit to guild bank
		if     (rfilter.guild.deposit and data.msg:match("deposited into the guild bank")) then
			-- Event: CHAT_MSG_SERVER - Data:msg="10000 c has been deposited into the guild bank."
			target, credits = 'Deposit into guild bank', data.msg:match('^(%d+) c')
			category, typeof = 'guild.deposit', 'Debit'

		-- Event: Withdraw from guild bank.
		elseif (rfilter.guild.withdraw and data.msg:match("from the guild bank")) then
			-- Event: CHAT_MSG_SERVER - Data:msg="10000 c has been added to your account from the guild bank."
			target, credits = 'Withdrawl from guild bank', data.msg:match('^(%d+) c')
			category, typeof = 'guild.withdraw', 'Credit'
		end
	end


	-- Kill the timer to avoid mutliple commits
	if (event ~= 'CHAT_MSG_SECTORD_MISSION' and timer1:IsActive() and target and credits) then 
--		test.print('Timer Killed') 
		timer1:Kill() 
		ledger.endtime = gkmisc.GetGameTime()
--		test.print('end='..tostring(ledger.endtime))
--		if ledger.starttime then test.print('duration='..tostring(ledger.endtime - ledger.starttime)) end
	end
	
	if (target and credits) then ledger.record(category, target, typeof, credits, notes) end
end

function ledger.record(category, target, typeof, credits, notes)
--test.print('committing record: category='..tostring(category)..' / target='..target..' / typeof='..tostring(typeof)..' / credits='..tostring(credits)..' / notes='..tostring(notes))
	local str = notes or ''
	if (ledger.vars.purchase_failed) then 
		str = 'Items purchase failed. ('..str..' purchased)' -- Not all items were purchased because not all items are available at this station.'
		ledger.vars.purchase_failed = false
	end
	
	credits = tonumber((string.gsub(credits, ',', '')))
	typeof = string.upper(typeof)
	if (typeof == 'DEBIT' and credits > 0) then credits = -credits end
	
	table.insert(ledger.list, {category = category, time = os.time(), reason = target, type = typeof, amount = tonumber(credits), notes = str})
	ledger.save(ledger.list)
end

function ledger.init:OnEvent(event, data)
	UnregisterEvent(self, "PLAYER_ENTERED_GAME")
	ledger.list = unspickle(LoadSystemNotes(ledger.notesid)) or {}
	ledger.viewer.build_dialog()
	ledger.viewer.edit.build_dialog()
	--ledger.viewer.options.build_dialog()
	print(ledger.vars.fontcolor..'Ledger Loaded  [ v'..ledger.version..' ]')
end

RegisterEvent(ledger.init, 'PLAYER_ENTERED_GAME')
RegisterEvent(ledger.log,  'CHAT_MSG_CONFIRMATION')
RegisterEvent(ledger.log,  'CHAT_MSG_SECTORD')
RegisterEvent(ledger.log,  'CHAT_MSG_SECTORD_MISSION')
RegisterEvent(ledger.log,  'CHAT_MSG_SERVER')
RegisterEvent(check_purchase, 'INVENTORY_ADD')

RegisterUserCommand("ledger", function(_,args) 
	local fontcolor = ledger.vars.fontcolor

	if (args == nil) then
		ledger.viewer.ui.dialog:Show()

	elseif (args[1] == 'fix042') then
		local idxs = {}
		for i = 1, #ledger.list do
			if (ledger.list[i].category == '') then table.insert(idxs, i) end
		end
		for i = #idxs, 1, -1 do
			table.remove(ledger.list, idxs[i]) 
		end
		ledger.save(ledger.list)
		print(fontcolor..'Blank records have been deleted.')
		
	elseif (args[1] == 'reset') then 
		ledger.list = {}
		ledger.save(ledger.list)
		ledger.vars.startcredits = GetMoney()
		gkini.WriteInt('Ledger', 'startcredits', ledger.vars.startcredits)
		print(fontcolor..'Ledger histories have been reset.')

	elseif (args[1] == 'lastten') then
		print("Placeholder: for printing last ten transactions")
	end
end)




-- *You complete a procurement mission
-- Event:CHAT_MSG_SECTORD_MISSION - Data:missionid=1587,msg="66558 credits received (41958 reimbursal)"
-- Event:MISSION_NOTIFICATION - Data:1587
-- Event:CHAT_MSG_SECTORD_MISSION - Data:missionid=1587,msg="Great!  Thanks for the delivery.  Feel free to sign up again if you're looking for more work."
-- Event:CHAT_MSG_SECTORD_MISSION - Data:missionid=1587,msg="Mission completed in 00:28.  Time bonus received, 2200 credits.<button title=\"Contact\"/>"
-- [Sat Nov 27 02:27:21 2010] 68758 credits added to your account.
-- Event:CHAT_MSG_SECTORD_MISSION - Data:missionid=0,msg="68758 credits added to your account."

-- *Partial procurement delivery
-- Event:CHAT_MSG_SECTORD_MISSION - Data:missionid=1593,msg="1 item delivered.  7 items remaining.  Go get the rest from Nyrius F-6, Asuin Tech.  (4662 credits received)<button title=\"Contact\"/>"
-- Event:CHAT_MSG_SECTORD_MISSION - Data:missionid=1595,msg="5 items delivered.  8 items remaining.  Go get the rest from Nyrius F-6, Asuin Tech.  (23310 credits received)<button title=\"Contact\"/>"


--[[When buying a ship, either with buyback or manually, 
Event: INVENTORY_ADD - Data:
	1: (number)	3949			<---- this is the ships engine
Event: SHIP_CHANGED - Data:
	1: (number)	3948
Event: INVENTORY_ADD - Data:
	1: (number)	3948
[Mon Jun  6 23:57:20 2011] 109 credits deducted from your account.
Event: CHAT_MSG_SECTORD_MISSION - Data:
	1: (table)	missionid=0,msg="109 credits deducted from your account."

vvv  This only happens if purchased manually, if detected, unset flag, and write normally
Event: CHAT_MSG_CONFIRMATION - Data:
	1: (table)	msg="1x of EC-98 purchased for a total price of 109c."
[Mon Jun  6 23:57:20 2011] 1x of EC-98 purchased for a total price of 109c.
^^^ -------------------------------------------------------------

Event: TRANSACTION_COMPLETED - Data:
	1: (number)	2
Event: PLAYER_UPDATE_STATS - Data:
	1: (number)	189776]]


--Event: CHAT_MSG_CONFIRMATION - Data: 1: (table)      msg="Preset purchase cancelled but some items may have been purchased."