-- ---------------------------------------------------------------
-- Edit dialog
-- ---------------------------------------------------------------

ledger.viewer.edit            = {}
ledger.viewer.edit.ui         = {}
ledger.viewer.edit.ui.dialog  = {}


ledger.viewer.edit.ui.date = iup.label{title = '', set = function(self, dat)
	self.title = os.date(ledger.format.date, dat)
end}

ledger.viewer.edit.ui.reason = iup.label{title = '', set = function(self, reason)
	self.title = reason
end}

ledger.viewer.edit.ui.amount = iup.label{title = '', set = function(self, amount)
	self.title = amount
end}

ledger.viewer.edit.ui.textbox = iup.text{expand = 'HORIZONTAL'}

ledger.viewer.edit.ui.save = iup.stationbutton{title = 'Save', action = function(self)
	local header = ledger.vars.header
	local map = ledger.viewer.matrix_list_map
	local notes = ledger.viewer.edit.ui.textbox.value
	local curline = tonumber(ledger.viewer.edit.ui.dialog.curline)

	ledger.list[map[curline]].notes = notes
	ledger.viewer.ui.matrix:setval(curline, header.notes[1], notes)
	ledger.viewer.updated = true
	ledger.viewer.edit.ui.cancel:action()
end}

ledger.viewer.edit.ui.cancel = iup.stationbutton{title = 'Cancel', action = function() 
	ledger.viewer.edit.ui.dialog:hide()
end}

function ledger.viewer.edit.build_dialog()
	local ui = ledger.viewer.edit.ui

	ledger.viewer.edit.ui.main = iup.pdarootframe {
		iup.stationsubframe{
			iup.vbox{
				iup.hbox{
					ui.date,
					iup.label{title = '--'},
					ui.reason,
					ui.amount,
					gap = 5,
				},
				iup.hbox{ui.textbox,},
				iup.hbox{
					iup.fill{},
					ui.save,
					iup.fill{},
					ui.cancel,
					iup.fill{},
				},
			},
		},
	}

	ledger.viewer.edit.ui.dialog = iup.dialog{
		iup.vbox{
			iup.fill{},
			iup.hbox{
				iup.fill{},
				ui.main,
				iup.fill{},
			},
			iup.fill{},
		},
		defaultesc = ui.cancel,
		defaultenter = ui.save,
		border = "NO",
		resize = "NO",
		menubox = "NO",
		topmost = "YES",
	}
	ledger.viewer.edit.ui.dialog:map()
end